package ims;

import java.io.*;
import java.awt.*;
import java.awt.event.*; 
import java.util.*;
 

//IMS Master Class

public class imsMaster extends Any{
  
  // Attributes
  protected imsGeneral general;
  protected imsLifeCycle  lifecycle;
  protected imsMetaMetaData metametadata;
  protected imsTechnical technical;
  private   imsEducational educational;  //Optional
  protected imsRights rights;  
  private   imsRelation[] relation; //Optional
  private   imsAnnotation[] annotation; //Optional
  protected imsClassification[] classification;
       
  //methods
  public imsMaster(){}; //constructor 

  public imsMaster(imsMetaMetaData aMetaMetaData, imsGeneral aGeneral,
		   imsLifeCycle aLifeCycle, imsTechnical aTechnical, 
		   imsEducational aEducational, imsRights aRights,
		   imsRelation[] aRelation, imsAnnotation[] aAnnotation,
		   imsClassification[] aClassification) {

      general = aGeneral;
      classification = aClassification;
      lifecycle = aLifeCycle;
      metametadata = aMetaMetaData;
      technical = aTechnical;
      rights = aRights;
      
      educational = aEducational;
      relation = aRelation;
      annotation = aAnnotation;
      
    }

  //output
  public String imsWrite2XMLString() {

      StringBuffer sb = new StringBuffer("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
      sb.append("<!DOCTYPE RECORD SYSTEM \"http://www.imsproject.org/xml/IMS-MD01.dtd\">");
      sb.append("<RECORD xmlns=\"http://www.imsproject.org/metadata/\">\n");

      sb.append(metametadata.imsWrite2XMLString()+"\n");
      sb.append(general.imsWrite2XMLString()+"\n");
      sb.append(lifecycle.imsWrite2XMLString()+"\n");
      sb.append(technical.imsWrite2XMLString()+"\n");

      //Optional
      if(educational != null) 
        sb.append(educational.imsWrite2XMLString()+"\n");
 
	  sb.append(rights.imsWrite2XMLString());

    //Optional
      if(relation!=null) 
 	    for(int i=0; i < relation.length; i++)
          sb.append(relation[i].imsWrite2XMLString()+"\n");
      
    //Optional
      if(annotation!=null) 
        for(int i=0; i < annotation.length; i++)
          sb.append(annotation[i].imsWrite2XMLString()+"\n");

      for(int i=0; i < classification.length; i++)
        sb.append(classification[i].imsWrite2XMLString()+"\n");

      
      sb.append("</RECORD>");
      return sb.toString();
  }
  
  public void imsWrite2XMLFile(String xmlFileName, String xmlString) throws IOException {
      File output = new File(xmlFileName+".xml");
      FileWriter out = new FileWriter(output);
      out.write(xmlString);
      out.close();
  }
}
